/*************************************************************************/
//FileName : fpfptr.h
//Name : Kaku
//Copyright (C) 2004 - 2008 by ISHIZUE Design Automation Corp. All Right Reserved.
//Date :2008/12/10
//Synopsis:
/*************************************************************************/
#ifndef _FPFPTR_H_
#define _FPFPTR_H_

#ifdef __cplusplus
extern "C" {
#endif

/*************************************************************************
 * ^錾
 *************************************************************************/
typedef unsigned int CDFG_ID_T;

/*************************************************************************
 * O[`
 *************************************************************************/
extern void     __fpf_funcinit  (const char * file_name, CDFG_ID_T file_id, const char * func_name, CDFG_ID_T func_id);
extern void     __fpf_funcquit  ();
extern void     __fpf_struct    (int struct_no, int sub_struct_no, const char * tag_name, int struct_size);
extern void     __fpf_memb      (int struct_no, const char * memb_name, CDFG_ID_T memb_id, int var_type, int var_ptrc, void * memb_offset, int memb_dimc, ...);
extern void     __fpf_varaddr   (int var_help_no, const char * var_name, CDFG_ID_T var_id, int is_module, int var_seg, int var_type, int var_ptrc, void * var_addr, int var_dimc, ...);
extern void *   __fpf_malloc    (int var_help_no, CDFG_ID_T var_id, int is_module, int var_type, int var_ptrc, int blk_size);
extern void *   __fpf_calloc    (int var_help_no, CDFG_ID_T var_id, int is_module, int var_type, int var_ptrc, int blk_c, int blk_size);
extern void *   __fpf_realloc   (int var_help_no, CDFG_ID_T var_id, int is_module, int var_type, int var_ptrc, void *, int blk_size );
extern void     __fpf_free      (void*);
extern void     __fpf_ptraddr   (int ptr_no, CDFG_ID_T port_id, int src_help_no, int target_look, void * src_addr, int ptr_type_no, int ptr_c, int is_upd , int rec_continue);
extern void     __fpf_if_ptraddr    (int ptr_no, CDFG_ID_T decl_id, int src_help_no);
extern void     __fpf_subif_ptraddr (int ptr_no, CDFG_ID_T decl_id, int src_help_no);

#ifdef __cplusplus
}
#endif

#endif // !_FPFPTR_H_


